/*
 * Worldvisions Weaver Software:
 *   Copyright (C) 1997-2002 Net Integration Technologies, Inc.
 *
 * Various little time functions...
 *
 */
#ifndef __WVTIMEUTILS_H
#define __WVTIMEUTILS_H

#include <sys/time.h>

typedef struct timeval WvTime;

/** Returns the number of milliseconds between times a and b. */
time_t msecdiff(const WvTime &a, const WvTime &b);

/** Returns the current time of day. */
WvTime wvtime();

/** Adds the specified number of milliseconds to a time value. */
struct timeval msecadd(const WvTime &a, time_t msec);

/** Normalizes the time value. */
inline void normalize(WvTime &tv)
{
    tv.tv_sec += tv.tv_usec / 1000000;
    tv.tv_usec %= 1000000;
}

/** Compares two time values. */
inline bool operator< (const WvTime &a,
    const struct timeval &b)
{
    return a.tv_sec < b.tv_sec || (a.tv_sec == b.tv_sec
        && a.tv_usec < b.tv_usec);
}

#endif // __WVTIMEUTILS_H
